package examples.ejb.extensions.readMostly;

import java.rmi.RemoteException;

import javax.ejb.EJBObject;


/**
 * The remote interface for the StockBean read-only EJB.  Note that this
 * interface doesn't define any "set" methods as this would break our goal
 * of defining a strictly read-only bean.
 *
 * @author Copyright (c) 1999-2000 by BEA Systems, Inc. All Rights Reserved.
 */

public interface Stock extends EJBObject {

  public String getSymbol() throws RemoteException;

  public double getPrice() throws RemoteException;

  public double get52weekHigh() throws RemoteException;
  
  public double get52weekLow() throws RemoteException;

  public long getVolume() throws RemoteException;

}
