@start rule: loadCheckForField
        try {
          if (!@isLoadedVarForField) {
            @callLoadMethodForField
          }
        @standardCatch
@end rule: loadCheckForField


@start rule: cmpGetMethod
  public @fieldClassForCmpField @getMethodNameForField() {
      int oldState = __WL_method_state;

      try {
        __WL_method_state = STATE_BUSINESS_METHOD;
        @loadCheckForField
        return @fieldNameForField;
      }
      finally {
        __WL_method_state = oldState;
      }
  }
@end rule: cmpGetMethod


@start rule: cmpSetMethod
  public void @setMethodNameForField(
    @fieldClassForCmpField @fieldNameForField) {
      int oldState = __WL_method_state;

      try {
        __WL_method_state = STATE_BUSINESS_METHOD;
        this.@fieldNameForField = @fieldNameForField;
        @isModifiedVarForField = true;
      }
      finally {
        __WL_method_state = oldState;
      }
  }
@end rule: cmpSetMethod

 
@start rule: oneToOneGetterBody_fkOwner
      int oldState = __WL_method_state;

      try {
        __WL_method_state = STATE_BUSINESS_METHOD;
        @loadCheckForField

        try {
          if (@fieldVarForField==null) {
            @perhapsDeclareFkVar
            @perhapsAssignFkVar
            if (!@fkVarForFieldIsNull)
              @fieldVarForField = (@classNameForField)
                @finderInvokerForField.findByPrimaryKey(@finderParamForField
                                                        @fkVarForField);
        }
        @standardCatch

        return @fieldVarForField;
      }
      finally {
        __WL_method_state = oldState;
      }
@end rule: oneToOneGetterBody_fkOwner


@start rule: oneToOneGetterBody
      int oldState = __WL_method_state;

      try {
        __WL_method_state = STATE_BUSINESS_METHOD;
        try {
          if (!@isCmrLoadedVarNameForField) {
             if (@verboseVar) {
                Debug.say("calling @finderVarForField with value of " + 
                     @ctxVar.getPrimaryKey());
             }

             try {
               @fieldVarForField = (@classNameForField)
                 @bmVarForField.scalarFinder(@finderVarForField, 
                   new Object[] {@ctxVar.getPrimaryKey()});
             } catch (ObjectNotFoundException onfe) {
               @fieldVarForField = null;
             }
             @isCmrLoadedVarNameForField = true;
             if (@verboseVar) { 
               if (@fieldVarForField == null)
                 Debug.say("bean not found.");               
               else 
                 Debug.say("bean was found.");               
             }
          }
        @standardCatch

        return @fieldVarForField;
      }
      finally {
        __WL_method_state = oldState;
      }
@end rule: oneToOneGetterBody


@start rule: oneToOneSetBody_fkOwner_preSetCheck
    @loadCheckForField

    try {
      if (!@fkVarForFieldIsNull) {
        @perhapsDeclareFkVar
        @perhapsAssignFkVar

        @relClassNameForField @beanVar = 
           (@relClassNameForField)@bmVarForField.lookup(@fkVarForField);
        @beanVar.@relatedDoSetForField(null);
      }
    @standardCatch
@end rule: oneToOneSetBody_fkOwner_preSetCheck


@start rule: oneToOneSetBody_preSetCheck
    try {
      @getMethodNameForField();
      if (@fieldVarForField !=null) {
        @relClassNameForField @beanVar = 
        (@relClassNameForField)@bmVarForField.lookup(
           @fieldVarForField.getPrimaryKey());
        @beanVar.@relatedDoSetForField(null);
      }
    @standardCatch
@end rule: oneToOneSetBody_preSetCheck


@start rule: oneToManySetBody_fkOwner_preSetCheck
    @loadCheckForField

    try {
      if (!@fkVarForFieldIsNull) {
        @perhapsDeclareFkVar
        @perhapsAssignFkVar

        @relClassNameForField @beanVar = 
          (@relClassNameForField)@bmVarForField.lookup(@fkVarForField);
        RDBMSSet @colVar = (RDBMSSet)
          @beanVar.@getRelatedMethodNameForField();
        @colVar.doRemove(@ctxVar.getEJBObject());
      }
    @standardCatch
@end rule: oneToManySetBody_fkOwner_preSetCheck


@start rule: oneToOneSetBody_fkOwner_postSetCheck
    try {
      if (!@fkVarForFieldIsNull) {
        @perhapsDeclareFkVar
        @perhapsAssignFkVar
        @relClassNameForField @beanVar = (@relClassNameForField)
          @bmVarForField.lookup(@fkVarForField);
        @beanVar.@relatedSetRestForField(
          (@remoteInterfaceForBean)@ctxVar.getEJBObject());
      }
    @standardCatch
@end rule: oneToOneSetBody_fkOwner_postSetCheck


@start rule: oneToManySetBody_fkOwner_postSetCheck
    try {
      if (!@fkVarForFieldIsNull) {
        @perhapsDeclareFkVar
        @perhapsAssignFkVar
        @relClassNameForField @beanVar = (@relClassNameForField)
          @bmVarForField.lookup(@fkVarForField);
        RDBMSSet @colVar = (RDBMSSet)
          @beanVar.@getRelatedMethodNameForField();
        @colVar.doAdd(@ctxVar.getEJBObject());
      }
    @standardCatch
@end rule: oneToManySetBody_fkOwner_postSetCheck


@start rule: oneToOneSetBody_postSetCheck
    try {
      if (@fieldVarForField !=null) {
        @relClassNameForField @beanVar = (@relClassNameForField)
        @bmVarForField.lookup(@fieldVarForField.getPrimaryKey());
        @beanVar.@relatedSetRestForField((@remoteInterfaceForBean)
          @ctxVar.getEJBObject());
      }
    @standardCatch
@end rule: oneToOneSetBody_postSetCheck


@start rule: oneToManySetBody
		if (__WL_method_state==STATE_EJB_CREATE) {
		  throw new IllegalStateException("The setXXX method for a " +
         "cmr-field may not be called during ejbCreate.  The setXXX " +
         "method should be called during ejbPostCreate instead.");
		}

    int oldState = __WL_method_state;
    try {
      __WL_method_state = STATE_BUSINESS_METHOD;

      try {
        /*
        if (@fieldNameForField !=null &&
            !(@fieldNameForField instanceof @collectionClassForField)) 
          throw new RDBMSException("Invalid collection class '" +
                                   @fieldNameForField.getClass().getName() +
                                   "' passed to method '" +
                                   "@setterMethodNameForField" +
                                   "'.  Must use a collection provided by " +
                                   "Weblogic RDBMS CMP.");
        */
        @getMethodNameForField();

        if (@fieldNameForField==@fieldVarForField)
          return;

        @fieldVarForField.clear();
        @fieldVarForField.addAll(@fieldNameForField);
      @standardCatch
    }
    finally {
      __WL_method_state = oldState;
    }
@end rule: oneToManySetBody


@start rule: oneToOneDoSetBody_fkOwner
    int oldState = __WL_method_state;

    try {
      __WL_method_state = STATE_BUSINESS_METHOD;
      @loadCheckForField

      if (@verboseVar) {
        Debug.say("[" + @ctxVar.getPrimaryKey() + 
                  "]called @doSetMethodNameForField...");
      }
      @isModifiedVarForField = true;
      @fieldVarForField = @fieldNameForField;
      if (@fieldVarForField == null) {
        if (@verboseVar) {
          Debug.say("setting field variable to null.");
        }
        @assignFkVarsNull_forField
      }
      else {
        try {
          if (@verboseVar) {
            Debug.say("setting field variable to new value.");
          }
          @assignFkVarsFkField_forField
        @standardCatch
      }
    }
    finally {
      __WL_method_state = oldState;
    }
@end rule: oneToOneDoSetBody_fkOwner


@start rule: oneToManyGetterBody_fkOwner
    int oldState = __WL_method_state;

    try {
      __WL_method_state = STATE_BUSINESS_METHOD;
      @loadCheckForField

      try {
        if (@fieldVarForField==null) {
          @perhapsDeclareFkVar
          @perhapsAssignFkVar
          if (!@fkVarForFieldIsNull)
            @fieldVarForField = (@classNameForField)
              @finderInvokerForField.findByPrimaryKey(@finderParamForField
                                                      @fkVarForField);
        }
      @standardCatch

      return @fieldVarForField;
    }
    finally {
      __WL_method_state = oldState;
    }
@end rule: oneToManyGetterBody_fkOwner


@start rule: oneToManyGetterBody
    int oldState = __WL_method_state;

    try {
      __WL_method_state = STATE_BUSINESS_METHOD;

      try {
        if (@fieldVarForField==null) {
           if (@verboseVar) {
              Debug.say("\t@fieldVarForField was null.");
           }

           @fieldVarForField = @allocateOneToManySet


        } 
      @standardCatch

      return @fieldVarForField;
    }
    finally {
      __WL_method_state = oldState;
    }
@end rule: oneToManyGetterBody


@start rule: ManyToManyGetterBody
    int oldState = __WL_method_state;

    try {
      __WL_method_state = STATE_BUSINESS_METHOD;
      try {
        if (@fieldVarForField==null) {
           if (@verboseVar) {
              Debug.say("\t@fieldVarForField was null.");
           }

           @fieldVarForField = @allocateManyToManySet
        }
      @standardCatch

      return @fieldVarForField;
    }
    finally {
      __WL_method_state = oldState;
    }
@end rule: ManyToManyGetterBody


@start rule: oneToOneSetRestBody_fkOwner
    int oldState = __WL_method_state;

    try {
      __WL_method_state = STATE_BUSINESS_METHOD;
      @loadCheckForField

      try {
        if (@verboseVar) {
          Debug.say("[" + @ctxVar.getPrimaryKey() + 
                    "]called @setRestMethodNameForField...");
        }
        if (!(@fkVarForFieldIsNull)) {
          if (@verboseVar) { Debug.say("\tvariable for field is not null."); }
          @perhapsDeclareFkVar
          @perhapsAssignFkVar

          @relClassNameForField @beanVar = 
           (@relClassNameForField) @bmVarForField.lookup(@fkVarForField);
          @beanVar.@relatedDoSetForField(null); 
        }
        @doSetMethodNameForField(@fieldNameForField);
      @standardCatch
    }
    finally {
      __WL_method_state = oldState;
    }
@end rule: oneToOneSetRestBody_fkOwner


@start rule: oneToOneSetRestBody
    int oldState = __WL_method_state;

    try {
      __WL_method_state = STATE_BUSINESS_METHOD;

      try {
        @getMethodNameForField();
        if (@fieldVarForField !=null) {
          @relClassNameForField @beanVar = (@relClassNameForField)
            @bmVarForField.lookup(@fieldVarForField.getPrimaryKey());

          @beanVar.@relatedDoSetForField(null);
        }

        @doSetMethodNameForField(@fieldNameForField);
      @standardCatch
    }
    finally {
      __WL_method_state = oldState;
    }
@end rule: oneToOneSetRestBody















