@start rule: main
@packageDeclaration

import weblogic.logging.MessageLogger;
 
/** 
 * Copyright (c) @year by BEA Systems, Inc. All Rights Reserved.
 * @exclude
 */
public class @className
{
@logMessages
}
@end rule: main

@start rule: logMessage
  /**
   * @logMessageDescription
   * @exclude
   *
   * messageid:  @logMessageId
   * severity:   @logMessageSeverity
   */
  public static String @logMethodName(@logArguments) @logExceptions {
    Object [] args = { @logArgumentClasses };
    MessageLogger.log(
	"@logMessageId",
	args,
	"@localizerClass");
    return "@logMessageId";
  }
@end rule: logMessage
