@start rule: main
@textPackageDeclaration

import java.text.MessageFormat;
import java.util.Locale;
import weblogic.i18n.Localizer;
import weblogic.i18ntools.L10nLookup;
 
/** 
 * Copyright (c) @year by BEA Inc. All Rights Reserved.
 */
public class @className {
  private Localizer l10n;
// constructors
  /**
   * @exclude
   */
  public @className() {
    l10n = L10nLookup.getLocalizer(Locale.getDefault(), "@formatterClass");
  }
  /**
   * @exclude
   */
  public @className(Locale l) {
    l10n = L10nLookup.getLocalizer(l, "@formatterClass");
  }

@textMessages
}
@end rule: main

@start rule: textMessage
  /**
   * @textMessageDescription
   * @exclude
   */
  public String @textMethodName(@textArguments) @textExceptions {
    Object [] args = { @textArgumentClasses };
    return MessageFormat.format(l10n.get("@textMessageId") , args);
  }
@end rule: textMessage
