package weblogic.i18ntools;

import weblogic.logging.MessageLogger;
 
/** 
 * Copyright (c) 2000 by BEA Systems, Inc. All Rights Reserved.
 * @exclude
 */
public class L10nLogger
{
  /**
   * Getting DomainMBean
   * @exclude
   *
   * messageid:  020000
   * severity:   debug
   */
  public static String logGetDomain()  {
    Object [] args = {  };
    MessageLogger.log(
	"020000",
	args,
	"weblogic.i18n.L10nLogLocalizer");
    return "020000";
  }

  /**
   * Creating I18nMBean
   * @exclude
   *
   * messageid:  020001
   * severity:   debug
   */
  public static String logCreateI18nMBean()  {
    Object [] args = {  };
    MessageLogger.log(
	"020001",
	args,
	"weblogic.i18n.L10nLogLocalizer");
    return "020001";
  }

  /**
   * I18n Properties: {0}
   * @exclude
   *
   * messageid:  020002
   * severity:   debug
   */
  public static String logPropertiesPath(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"020002",
	args,
	"weblogic.i18n.L10nLogLocalizer");
    return "020002";
  }

  /**
   * I18n user properties: {0}
   * @exclude
   *
   * messageid:  020003
   * severity:   debug
   */
  public static String logUserPropPath(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"020003",
	args,
	"weblogic.i18n.L10nLogLocalizer");
    return "020003";
  }

  /**
   * Unable to access I18n properties file: {0}
   * @exclude
   *
   * messageid:  020004
   * severity:   warning
   */
  public static String logNoProps(String arg0, Throwable arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"020004",
	args,
	"weblogic.i18n.L10nLogLocalizer");
    return "020004";
  }

  /**
   * Unable to access user i18n properties file: {0}
   * @exclude
   *
   * messageid:  020005
   * severity:   warning
   */
  public static String logNoUserProps(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"020005",
	args,
	"weblogic.i18n.L10nLogLocalizer");
    return "020005";
  }

  /**
   * Getting resource bundle for {0}
   * @exclude
   *
   * messageid:  020006
   * severity:   info
   */
  public static String logGetBundle(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"020006",
	args,
	"weblogic.i18n.L10nLogLocalizer");
    return "020006";
  }

  /**
   * Accessing I18N MBean
   * @exclude
   *
   * messageid:  020007
   * severity:   debug
   */
  public static String logGetI18nMBean()  {
    Object [] args = {  };
    MessageLogger.log(
	"020007",
	args,
	"weblogic.i18n.L10nLogLocalizer");
    return "020007";
  }

  /**
   * Refreshing I18n Properties
   * @exclude
   *
   * messageid:  020008
   * severity:   debug
   */
  public static String logRefresh()  {
    Object [] args = {  };
    MessageLogger.log(
	"020008",
	args,
	"weblogic.i18n.L10nLogLocalizer");
    return "020008";
  }


}
