package weblogic.servlet.jsp.stdtag;

import java.util.List;
import java.util.ArrayList;
import org.xml.sax.AttributeList;
import org.xml.sax.SAXException;
import weblogic.xml.dtdc.XmlElement;

public class Urn extends XmlElement implements Cloneable {

  // ============================================================
  // Constructor

  public Urn(String name, AttributeList attributes) throws SAXException {
    if(!name.equals("urn")) {
      throw new SAXException("Attempt to construct a " + getClass().getName() + " with a " +
                             name + " element");
    }
    initialize(name, attributes);
  }

  public Urn() {}

  public void initialize(String name, AttributeList attributes) throws SAXException {

  }
  
  public boolean isEmpty() {
    return false;
  }

  public String getElementName() { return "urn"; }

  // ============================================================
  // Attributes


  // ============================================================
  // Contained Elements

  public Urn addDataElement(String string) {
    return (Urn) super._addDataElement(string);
  }

  // ============================================================
  // Cloneable implementation

  public Object clone() throws java.lang.CloneNotSupportedException {
    return super.clone();
  }

  


}

