package examples.ejb.extensions.readMostly;

import java.rmi.RemoteException;

import javax.ejb.EJBHome;
import javax.ejb.FinderException;

/**
 * The home interface for the StockBean read-only EJB.  Note that interface
 * doesn't define any create methods.  A client can only obtain a reference
 * to a StockBean by using the findByPrimaryKey method declared here.
 *
 * @author Copyright (c) 1999-2000 by BEA Systems, Inc. All Rights Reserved.
 */

public interface StockHome extends EJBHome {

  Stock findByPrimaryKey(String symbol) 
    throws FinderException, RemoteException;

}
