package examples.ejb.extensions.readMostly;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;


/**
 * The home interface for the StockWriterBean.  Note that in contrast to
 * the home interface for the read-only bean, StockBean, this interface
 * does define a create method.
 *
 * @author Copyright (c) 1999-2000 by BEA Systems, Inc. All Rights Reserved.
 */

public interface StockWriterHome extends EJBHome {

  public StockWriter create(String symbol, double price, long volume)
    throws CreateException, RemoteException;

  public StockWriter findByPrimaryKey(String symbol)
    throws FinderException, RemoteException;

}
