#!/bin/sh

# Copyright (c) 2000 BEA Systems, Inc. All Rights Reserved.
# You must set your environment by running the setExamplesEnv shell script 
# prior to executing this script.

# Create the build directory, and copy the deployment descriptors into it
mkdir -p build build/META-INF
cp -f ejb-jar.xml weblogic-ejb-jar.xml build/META-INF

# Compile EJB classes into the build directory (jar preparation)
javac -d build  MessageTraderBean.java

# Make a EJB jar file, including XML deployment descriptors
(cd build; jar cv0f std_ejb20_message.jar META-INF examples)
# Run EJBC on jar file
java -classpath "$WL_HOME/lib/weblogic_sp.jar:$WL_HOME/lib/weblogic.jar" weblogic.ejbc \
    -compiler javac build/std_ejb20_message.jar \
    $APPLICATIONS/ejb20_message.jar

# Compile EJB interfaces & client app into the clientclasses directory
javac -d $CLIENT_CLASSES  Client.java

