# Copyright (c) 2000 BEA Systems, Inc. All Rights Reserved.
# You must set your environment by running the setExamplesEnv shell script 
# prior to executing this script.

# Create the build directory, and copy the deployment descriptors into it
mkdir -p build build/images build/WEB-INF build/WEB-INF/classes
cp -f web.xml build/WEB-INF
cp -f error.jsp build
cp -f hello.html build
cp -f cookie.jpg build
cp -f BEA_Button_Final_web.gif build/images

# Compile servlet class into the build directory (jar preparation)
cd ../../servlets
javac -d ../webapp/cookie/build/WEB-INF/classes CookieCounter.java

# Make a WAR file, including XML deployment descriptors
cd ../webapp/cookie/build
jar cv0f $APPLICATIONS/cookie.war WEB-INF images cookie.jpg error.jsp hello.html images/BEA_Button_Final_web.gif
cd ..
