package weblogic.servlet.jsp.wltag;

import java.util.List;
import java.util.ArrayList;
import org.xml.sax.AttributeList;
import org.xml.sax.SAXException;
import weblogic.xml.dtdc.XmlElement;

public class Jsptaglib extends XmlElement implements Cloneable {

  // ============================================================
  // Constructor

  public Jsptaglib(String name, AttributeList attributes) throws SAXException {
    if(!name.equals("jsptaglib")) {
      throw new SAXException("Attempt to construct a " + getClass().getName() + " with a " +
                             name + " element");
    }
    initialize(name, attributes);
  }

  public Jsptaglib() {}

  public void initialize(String name, AttributeList attributes) throws SAXException {
    if (attributes.getValue("name") != null) {
	nameValue = attributes.getValue("name");
    }
    attributeValues.put("name", nameValue);

  }
  
  public boolean isEmpty() {
    return false;
  }

  public String getElementName() { return "jsptaglib"; }

  // ============================================================
  // Attributes

  private String nameValue="";
  public String getNameAttribute() {
    return nameValue == null ? "" : nameValue;
  }
  public Jsptaglib setNameAttribute(String value) {
    nameValue = value;

    attributeValues.put("name", nameValue);
    return this;
  }


  // ============================================================
  // Contained Elements

  public Jsptaglib addDataElement(String string) {
    return (Jsptaglib) super._addDataElement(string);
  }

  // ============================================================
  // Cloneable implementation

  public Object clone() throws java.lang.CloneNotSupportedException {
    return super.clone();
  }

  
  private List tagSubElements = new ArrayList();
  public List getTagElements() { return tagSubElements; }
  public Jsptaglib addTagElement(Tag subelement) {
    tagSubElements.add(subelement);
    subElements.add(subelement);
    return this;
  }



}

