@start rule: main
package @package_name;

import java.io.*;
import java.net.*;
import java.util.Hashtable;
import java.util.Locale;
import java.util.Map;
import org.w3c.dom.*;
import org.xml.sax.*;
import org.xml.sax.helpers.ParserFactory;

public class @parser_class_name extends weblogicx.xml.parser.BaseParser {

  // ============================================================
  // Generated Code

  public void parse(char[] chars) throws SAXException {
    boolean done = false;
    int startLine = currentLine;
    dh.setDocumentLocator(this);
    dh.startDocument();
    while(current != chars.length && !done) {
@parser
    }
    if(done) throw new SAXParseException("Could not parse (bad close tag): starting at line " + startLine, this);
    dh.endDocument();
  }

@read_element_declarations
  
  // ============================================================
  // Constructor

  public @parser_class_name() {
    names  = new String[@max_attributes];
    types  = new String[@max_attributes];
    values = new String[@max_attributes];
    allNames  = new String[@max_attributes];
    allTypes  = new String[@max_attributes];
    allValues = new String[@max_attributes];
    allElements = new String[@max_attributes];
@set_attribute_types
  }

}
@end rule: main

@start rule: readAttribute
{String value = _readAttribute(chars);
@set_attribute_found
@ensure_unique
if(true@valid_attribute) throw new SAXParseException("Not a valid attribute value: [" + value + "]", this);
putAttribute("@attribute_realname", "@attribute_type", value);}
@end rule: readAttribute

@start rule: read_element_declaration
public void @read_element_method_name(char[] chars) throws SAXException {
  int startLine = currentLine;
  try {
    reset();
    loadAttributes("@element_name");
    boolean emptyTag = @read_element_attributes_method_name(chars);
    dh.startElement("@element_name", this);
    boolean done = false;
    while(!done && !emptyTag) {
@read_element
    }
    dh.endElement("@element_name");
  } catch(ArrayIndexOutOfBoundsException aioobe) {
    throw new SAXParseException("@element_name not closed, starts at line " + startLine, this);
  }
}

public boolean @read_element_attributes_method_name(char[] chars) throws SAXException {
  int startLine = currentLine;
  boolean done = false;
  boolean emptyTag = false;
@declare_required_attributes
  while(!done) {
@read_attributes
  }
@ensure_required_attributes
  return emptyTag;
}

@end rule: read_element_declaration

